package ogloszenia.soap;

import jakarta.jws.WebParam;
import jakarta.jws.WebResult;
import jakarta.jws.WebService;
import ogloszenia.baza.sqlite.DostepDoBazySqlite;
import ogloszenia.baza.sqlite.OgloszenieDAO;
import ogloszenia.exn.BladBazyDanych;
import ogloszenia.exn.NieznanyRekord;
import ogloszenia.model.OgloszenieSamochodowe;

import java.math.BigDecimal;
import java.util.List;

@WebService
public class Ogloszenia {

    @WebResult(name="ogloszenie")
    public List<OgloszenieSamochodowe> readAll() throws BladBazyDanych {
        try (DostepDoBazySqlite db = DostepDoBazySqlite.newSQLite()) {
            OgloszenieDAO dao = db.newOgloszenieDAO();
            return dao.readAllFull();
        }
    }

    @WebResult(name="ogloszenie")
    public OgloszenieSamochodowe readOne(@WebParam(name="id") int idOgloszenia) throws BladBazyDanych, NieznanyRekord {
        try (DostepDoBazySqlite db = DostepDoBazySqlite.newSQLite()) {
            OgloszenieDAO dao = db.newOgloszenieDAO();
            return dao.findByIdFull(idOgloszenia);
        }
    }

    @WebResult(name="ogloszenie")
    public List<OgloszenieSamochodowe> readByPrice(
            @WebParam(name="min") BigDecimal min,
            @WebParam(name="max") BigDecimal max) throws BladBazyDanych {
        try(DostepDoBazySqlite db = DostepDoBazySqlite.newSQLite()) {
            OgloszenieDAO dao = db.newOgloszenieDAO();
            return dao.ogloszeniaWedlugCeny(min, max);
        }
    }

    public void save(
            @WebParam(name="ogloszenie") OgloszenieSamochodowe ogloszenie) throws BladBazyDanych {
        try(DostepDoBazySqlite db = DostepDoBazySqlite.newSQLite()) {
            OgloszenieDAO dao = db.newOgloszenieDAO();
            dao.save(ogloszenie);
        }
    }
}
